; main include file for bave

STARTBANK	EQU	$20		; beginning bank (0 for 256k cart, $20 for bugged 256k cart)
AVOID3fc0	EQU	1		; don't access this memory in browser as it's used to bank-switch
RASTEND		EQU	$2007	; address of end custom raster code routine

BAVE_BROWSE	EQU	$2ffe	; jump vector for memory browser init
BAVE_TESTD	EQU	$2ffc	; test d-trigger of control
BAVE_WHATEV	EQU	$2ffa	; Add additional routines to use

; module standard data block between $3fb0 and $3fbf
MOD_ID		EQU	$3f7c	; (2 bytes) ID of module
MOD_MODLEN	EQU	$3f7e	; (2 bytes) final addy of module code before padding

GSTATE_INTRO	EQU	0	; BAVE intro screen
GSTATE_SPLASH	EQU	1	; Splash screen
GSTATE_DEBUG	EQU	2	; debug browser

DSTATE_NONE		EQU	0			; no debug work at all
DSTATE_GAMETICK	EQU	1			; default debugging, gametick shown in bottom-right corner
DSTATE_SHOWBYTE	EQU	2			; display showb1 and showb2 in bottom-right corner
DSTATE_BROWSE	EQU	3			; display block of memory

RAST_CUSTOM		EQU	7			; custom raster code being used
LOGIC_CUSTOM	EQU	7			; custom logic code being used

; 16 bits of object status in object structure
OBJ_DIRTY		EQU	0			; object has moved/animated and needs to be redrawn
OBJ_DRAWN		EQU 1			; object has been drawn so far this tick
OBJ_MOVED		EQU	2			; object moved this frame
OBJ_CLIPPED		EQU	3			; object did not fit on the screen

; joystick bits
JoyUp			EQU	0		; joy up bit
JoyDown			EQU	1		; joy down bit
JoyLeft			EQU	2		; joy left bit
JoyRight		EQU	3		; joy right bit
JoyTrig			EQU	4		; trigger bit

; ram usage
GameState		EQU	$4fbf		; Main State of game
CustBank		EQU	$4fc0		; Custom Logic bank being used
CustLogic		EQU	$4fc1		; (2b) address of module/custom code called once a tick
RasterTemp		EQU	$4fc3		; (2b) temp ram for raster code
RasterCode		EQU	$4fc5		; (2b) points to custom raster code
RasterBank		EQU	$4fc7		; raster code bank and option bits (see RAST_ equates above)
LastSetBank		EQU	$4fc8		; bank of last bank-switch
DebugTemp		EQU	$4fc9		; (2b) temp addr var used by debug routines
DebugAddr		EQU	$4fcb		; addr var used by debug routines
DebugBank		EQU	$4fcd		; bank var used by debug routines
DebugState		EQU	$4fce		; which mode debugging is in
GameTick		EQU	$4fcf		; (2b) count frames since game loop started
CurrentIntLine	EQU $4fd1		; current interrupt line number
VBlankHit		EQU	$4fd2		; flag for hitting vblank
ShowB1   		EQU	$4fd3		; misc debug byte #1 to show
ShowB2  		EQU	$4fd4		; misc debug byte #2 to show
DebTrigs		EQU	$4fd5		; Controller 1-4 D-trigger (debounced)
TickRND			EQU	$4fd6		; (2b) Random byte per game tick
; Stack area between $4fd8-$4fff
